<?php
/* ====================================
 * Plugin Name: Синхронизация Frontpad и Woocommerce
 * Description: Плагин для синхронизации фронтпад с вукомерс
 * Author:      Allslava
 * Author URI:  https://allslava.ru/
 * Plugin URI:  https://allslava.ru/plagin-dlya-sinhronizacii-vukommers-i-frontpad/
 * Version: 1.10
 * ==================================== */

// Устанавливаем маску для ввода телефона на странице оформления
add_action('wp_enqueue_scripts', 'my_maskedinput');
function my_maskedinput() {
    if (is_checkout()) {
        wp_enqueue_script('maskedinput', '/wp-content/plugins/WoocommerceToFrontpad/jquery.maskedinput.js', array('jquery'));
        add_action( 'wp_footer', 'masked_script', 999);
    }
}
 function masked_script() {
    if ( wp_script_is( 'jquery', 'done' ) ) {
?>
    <script type="text/javascript">
        jQuery( function( $ ) {
            $("#billing_phone").mask("+7(999)999-99-99");
        });
    </script>
<?php
    }
}

/*
 * Отправка данных заказа во Frontpad
 */

add_action( 'woocommerce_thankyou', 'otpravka_zakaza_v_frontpad' );

function otpravka_zakaza_v_frontpad( $order_id ) {
    $order         = wc_get_order( $order_id );
    $parol_api = 'HHn6tGD39f4GahNDktTeeiNs5Gfb4ifAYztb5Y455SA54aydybhDnZTft4hhasGYR4ZGNQAEy2zi3SniYAN9hyeEirNkHh7k9TYNzhdS7B5Zef74FH3R57fdiYrY5i756REr2H8Y83Gd7E6DaYe6Rn848kK4AFYtinH9ZGYTys2sYTTZD3SfbR8a5G4sbKKn3hnKR9taresa2aZn3Ez5ft594Yr6y4fh9zTQyaQKf7K68zh23FR83H7Rsk';
    $email         = $order->billing_email;
    $phone         = $order->billing_phone;
	
	$phone = str_replace(array('(',')', '-'),'',$phone); // Очищаем поле телефон от ненужных символов
    $shipping_type = $order->get_shipping_method();
    if ( $order->get_payment_method_title() == 'Оплата при получении' ) {
        $shipping_type = '';
    } else {
        $shipping_type = 947;
    }
    $shipping_cost = $order->get_total_shipping();

    // получение данных товара

    $items      = $order->get_items();
    $item_name  = array();
    $item_qty   = array();
    $item_price = array();
    $item_sku   = array();

    // установка полей адреса

    $user_id        = $order->user_id;
    $address_fields = array(
        'country',
        'title',
        'given_name',
        'surname',
        'street',
        'house',
        'pod',
        'et',
        'apart',
    );

    $order_details = array();
    foreach ( $order->get_meta_data() as $item ) {
        $order_details[ $item->jsonSerialize()['key'] ] = $item->jsonSerialize()['value'];
    }
    $address = array();
    if ( is_array( $address_fields ) ) {
        foreach ( $address_fields as $field ) {
            $address[ 'billing_' . $field ]  = get_user_meta( $user_id, 'billing_' . $field, true );
            $address[ 'shipping_' . $field ] = get_user_meta( $user_id, 'shipping_' . $field, true );
            $address[ 'billing_' . $field ]  = $order_details[ '_billing_' . $field ];
            $address[ 'shipping_' . $field ] = $order_details[ '_shipping_' . $field ];
        }
    }
    $address['pre_order'] = get_post_meta( $order_id, 'pre_order', true );

    foreach ( $items as $item_id => $item ) {

        $item_name[]          = $item['name'];
        $item_qty[]           = $item['qty'];
        $item_price[]         = $item['line_total'];
        $item_id              = $item['product_id'];
        $product              = new WC_Product( $item['product_id'] );
        $product_variation_id = $item['variation_id'];
        $product              = $order->get_product_from_item( $item );
        
        // Получение артикула
        $item_sku[] = $product->get_sku();

    }


    // сбор данных для отправки
    $data = array(
        'secret'   => $parol_api,
        'street'   => $address['billing_street'],
        'home'     => $address['billing_house'],
        'pod'      => $address['billing_pod'],
        'et'       => $address['billing_et'],
        'apart'    => $address['billing_apart'],
        'phone'    => $phone,
        'mail'     => $email,
        'descr'    => $order->get_customer_note(),
        'name'     => $address['billing_given_name'] . ' ' . $address['billing_surname'],
        'pay'      => $shipping_type,
        'datetime' => date( 'Y-m-d G:i:s', $order->get_date_created()->getOffsetTimestamp() ),
    );
    
    // если указан адрес доставки, берем данные оттуда, если нет, то из платежного адреса
    if ( $address['shipping_street'] != "" ) {
        $data['street'] = $address['shipping_street'];
    }
    if ( $address['shipping_house'] != "" ) {
        $data['home'] = $address['shipping_house'];
    }
    if ( $address['shipping_pod'] != "" ) {
        $data['pod'] = $address['shipping_pod'];
    }
    if ( $address['shipping_et'] != "" ) {
        $data['et'] = $address['shipping_et'];
    }
    if ( $address['shipping_apart'] != "" ) {
        $data['apart'] = $address['shipping_apart'];
    }
    if ( ( $address['shipping_given_name'] != "" ) && ( $address['shipping_surname'] != "" ) ) {
        $data['name'] = $address['shipping_given_name'] . ' ' . $address['shipping_surname'];
    }
    if ( $address['pre_order'] != '' ) {
        $data['datetime'] = date( 'Y-m-d G:i:s', strtotime( $address['pre_order'] ) );
    }
    foreach ( $order->get_items( 'shipping' ) as $item_id => $shipping_item_obj ) {
        $data['descr'] = $data['descr'] . ' Доставка: ' . $shipping_item_obj->get_method_title();
    }

    $query = '';
	
    // подготовка запроса
    foreach ( $data as $key => $value ) {
        $query .= "&" . $key . "=" . $value;
    }

    // содержимое заказа
    foreach ( $item_sku as $key => $value ) {
        $query .= "&product[" . $key . "]=" . $value . "";
        $query .= "&product_kol[" . $key . "]=" . $item_qty[ $key ] . "";
    }

    // отправка запроса API через cURL
    $ch = curl_init();

    curl_setopt( $ch, CURLOPT_URL, "https://app.frontpad.ru/api/index.php?new_order" );
    curl_setopt( $ch, CURLOPT_FAILONERROR, 1 );
    curl_setopt( $ch, CURLOPT_RETURNTRANSFER, 1 );
    curl_setopt( $ch, CURLOPT_SSL_VERIFYPEER, false );
    curl_setopt( $ch, CURLOPT_SSL_VERIFYHOST, false );
    curl_setopt( $ch, CURLOPT_TIMEOUT, 30 );
    curl_setopt( $ch, CURLOPT_POST, 1 );
    curl_setopt( $ch, CURLOPT_HEADER, false );
    curl_setopt( $ch, CURLOPT_POSTFIELDS, $query );

    $response = curl_exec( $ch );

    curl_close( $ch );

    $response = json_decode( $response, true );

    if ( $response['result'] == 'success' ) {
        update_post_meta( $order_id, 'Frontpad Order ID', sanitize_text_field( $response['order_id'] ) );
        update_post_meta( $order_id, 'Frontpad Order Number', sanitize_text_field( $response['order_number'] ) );

    } else {
        switch ( $response['error'] ) {
            case 'cash_close' :
                echo 'Cмена закрыта';
                echo "<script>jQuery(document).ready(function ($) {
    var popup_id = 948;
    MasterPopups.open(popup_id);
    //Or using a jQuery selector
    $('.mpp-popup-' + popup_id).MasterPopups();
});
</script>";
                $order->update_status( 'failed' );
                break;
            case 'invalid_product_keys' :
                echo 'Неверный массив товаров';
                $order->update_status( 'failed' );
                break;
        }
    }

}

?>
